# Release Notes

## 6.17.6 (xxxx)

## 6.17.5 (2014-05-12)

* JSON/XML serialization migrated to Jackson2! XML serialization may be incompatible and
  will be dropped in 6.17.6.

* Documentation of public REST API migrated from jax-doclets to RAML

### Configuration changes

* New configuration option Shop.strictHostHeaderCheck. Controls strictness of checking
  of the incoming request. If set to true (default for production) the host header will
  need to match the host set as system or shop domain. Does not yet consider multiple
  domains per shop feature.

### Library Upgrades

* slf4j:1.7.7, logback:1.1.2, spring:4.0.3.RELEASE, mysql-connector-java:5.1.30,
  tomcat-jdbc:8.0.5, spring-hateoas:0.10.0.RELEASE, hk2:2.3.0-b04,
  hibernate-validator:5.1.0.Final, jetty:9.1.4.v20140401, solr:4.7.2,
  flying-saucer-pdf:9.0.6, logstash-logback-encoder:2.6, selenium:2.41.0,
  epages-soapclient:1.4.14, nvi18n:1.1

### Solr related changes (reindexing required)

* Indexing change: Unified Predef- and other string fields for faceting. (EPG-31849)

* Cleanup of attributes cache in mongo required (db.attributes.drop())

## 6.17.4 (2014-03-24)

### Library Upgrades

* slf4j:1.7.6, logback:1.1.1, guava:16.0.1, spring:4.0.2.RELEASE, joda_convert:1.6,
  mysql-connector-java:5.1.29, spring-batch:2.2.5.RELEASE, spring-data-mongodb:1.4.1.RELEASE,
  jersey:2.7, hk2:2.3.0-b01, jetty:9.1.3.v20140225, solr:4.7.0, pdfbox:1.8.4,
  logstash-logback-encoder:2.5, selenium:2.40.0, groovy:2.2.2, epages-soapclient:1.4.12,
  nv18n:1.11, jackson:1.9.13, jackson2:2.3.2, spring-hateoas:0.9.0.RELEASE

### Configuration changes

* New config option. ServiceApiSoap.productAvailabilityTextEnabled. Defaults to false.
  Used to control the fetching of product attribute "AvailabilityText", which was introduced in 6.17.4.
  Only enable, if epages perl version is 6.17.4 or higher.

## 6.17.3 (2014-02-06)

### Library Upgrades

* spring-data-mongodb:1.3.3-RELEASE, solr:4.6.1, epages-soapclient:1.4.8

### Configuration changes

* New config section: ServiceApiSoap. Used to configure connection parameters to epages6 SOAP interface.
  maxConnections=20 (max http connections total), maxConnectionsPerHost=10 (max http connections per hostname)

## 6.17.2 (2014-01-16)

### Library Upgrades

* mysql-connector-java:5.1.28, flyway-gradle-plugin:2.3.1, selenium:2.39.0, findbugs:2.0.3,
  hk2:2.2.0, xhtmlrenderer:9.0.4, jersey:2.5.1, spring:4.0.0, jetty:9.1.1, epages-soapclient:1.4.7,
  solr:4.6.0

## 6.16.8 (2014-01-15)

* Maintainance release due to library upgrade.

### Library Upgrades

* xhtmlrenderer:9.0.4

## 6.17.1 (2013-12-18) - DO NOT USE IN PRODUCTION.

* Re-added Pdf.baseUrl configuration property, to be able to resolve URLs for PDFs, if WebRoot is not available
  locally. (also contained in 6.16.5)

### Known Issues

* PermGen MemoryLeak in HK2!

* PDF rendering using local/NFS resolution broken!

## 6.17.0

### Configuration changes

* No more automatic task recovery, so Task.recovererDelayInMillis configuration option is removed.
  Instead you should use the REST API to trigger task recovery based on task status, storename or
  shop GUID. (/rs/queue/recovery)

* New ENV variable EPAGESJ_LOG_ARCHIVE. If set, logback will rotate into this directory, if unset
  archives still go into ./logs/archive/

### Solr related changes (reindexing required)

* Indexing change: New field "ObjectPath" in schema.xml

## 6.16.7 (2013-12-18)

### Confugration changes

* Bugfix release without configuration changes.

### Breaking API changes

* XML serialization of task status changed to upper case, to be consistent with JSON.
  Beware that XML serialization is deprecated, and may be discontinued in a future version
  of epagesj.

### Library Upgrades

* hk2:2.2.0-b27, jersey:2.4.1

## 6.16.6 (2013-12-10) - DO NOT USE IN PRODUCTION.

### Configuration changes

* Bugfix release without configuration changes.

* Does not contain the new Public REST API.

### Known Issues

* PermGen MemoryLeak in HK2!

## 6.16.5 (2013-11-28) - DO NOT USE IN PRODUCTION.

* Internal release containing new public REST API, based on 6.17.0 development.

## 6.17.0 (2013-10-25)

## 6.16.4 (2013-10-09)

* Bugfix release without configuration changes.

## 6.16.3 (2013-09-19)

* Bugfix release without configuration changes.

## 6.16.2 (2013-08-21)

### Configuration changes

* Added logstash-compatible logger in logback-epagesj.xml and logback-solr.xml (disabled by default)

## 6.16.1 (2013-08-06)

### Configuration changes

* Configuration for disabling the "sorting by position" removed again. The algorithm has been
  rewritten for better scalability. (Index.sortingByPositionEnabled)

* Small change on logback-epagesj.xml : Set com.epages.product.reader explicitly to "WARN" to avoid
  possible problems, when user is setting DEBUG on root logger.

## 6.15.8 (2013-07-01)

* Bugfix release without config changes.

* Added review changes for sorting algorithm.

## 6.16.0 (2013-06-26)

### Configuration changes

* recovererDelayInMillis set to -1. This disables task recovery by default. In most cases task recovery is
  not wanted. Instead you should schedule a full reindex for your shops.

## 6.15.7 (2013-06-11)

* Backport of replaced sorting algorithm.

## 6.15.6 (2013-05-27) - DO NOT USE IN PRODUCTION

### Known Issues

* Has a critical issue on task rescheduling. Do not use!

## 6.15.5 (2013-05-17)

### Configuration changes

* Configuration for disabling the new "sorting by position" added. This feature is known to cause problems on big
  installations. The default has been set to "off" (Index.sortingByPositionEnabled - default:false)

## 6.15.4 (2013-04-12)

### Configuration changes

* Auto-generation of epagesj.sample.conf. This causes this file to look completely different, although the relevant
  configuration changes are just the ones below.

* Server section moved to EPagesJServer

* Changed SolrClient.updateQueueSize default from 500 to 50. This makes memory consumption of epagesj more stable in
  cases, where Solr cannot keep up. This has not been seen in production yet. It is more a safety measure.

* Changed SolrClient.addDocsBufferSize default from 500 to 100. Same here. Don't accumulate too many documents to stabilize
  memory consumption.

* Changed Solr.autoOptimizeCheckInSecs default from 120 to 3600. Only check if core optimization is necessary once every hour.
  This should be disabled completely on big sites anyway. core optimization is a very expensive operation in
  solr and only brings short-term benefits because of constant index fragmentation due to index updates.
  Usually the merge strategy configured inside solr is good enough to keep index fragmentation on a stable level.

* Changed DSPool.maxWait default from 1000 to 30000. 30 seconds is the default for webapps to wait for a database connection.
  We experienced production sites that could not free database connections quick enough, which was causing tasks
  to fail.

## 6.15.3 (2013-05-28)

### Configuration changes

* Merged all search and suggest field configurations into two remaining entries: Search.suggestQueryfields and Search.searchQueryfields
  We replaced the phonetic index all together. As a replacement we introduced a spell-checking fallback query implementation with
  a spellcheck index on product name, manufacturer and category names.

## Manual update steps

* Drop the Mongo collections: "use epagesj; db.tasks.drop(); db.attributes.drop(); db.categories.drop();"

* Reindex all Stores: $PERL $EPAGES_CARTRIDGES/DE_EPAGES/RemoteSearch/Scripts/manageIndex.pl -storename Store -update -all
